#!/usr/bin/osascript

set SAVE_PATH to "~/Library/Application\\ Support/Best\\ Uptime.txt"

do shell script "date +%s"
set currentSeconds to result as number
set currentMinutes to currentSeconds div 60

do shell script "sysctl -n kern.boottime"
characters 9 thru ((offset of "," in result) - 1) of result as string
set bootSeconds to result as number
set bootMinutes to bootSeconds div 60

set upMinutes to currentMinutes - bootMinutes

set output to "Up " & formatTime(upMinutes)
set output to output & "\n---\n"

set fileMinutes to 0
try
	do shell script "cat " & SAVE_PATH
	set fileMinutes to result as integer
end try

if upMinutes > fileMinutes then
	do shell script "printf " & upMinutes & " > " & SAVE_PATH
end if

if upMinutes  fileMinutes then
	set output to output & "New Best!|color=#008800"
else
	set output to output & "Best: " & formatTime(fileMinutes)
end if

set output to output & "\n---\nUptime Script v2 by junebeetle"

return output

to formatTime(timeMinutes)
	set temp to timeMinutes
	
	set outMinutes to temp mod 60
	set temp to temp div 60
	set outHours to temp mod 24
	set outDays to temp div 24
	
	set output to ""
	if outDays > 0 then
		set output to output & outDays & "d "
	end if
	
	if outHours > 0 then
		set output to output & outHours & "h "
	end if
	
	if outMinutes > 0 or length of output is 0 then
		set output to output & outMinutes & "m"
	end if
	
	return output
	
end formatTime